<script setup lang="ts">
const emits = defineEmits<{
  update: [value: File]
  clear: []
}>()

const props = defineProps<{
  index: number
  imageUrl: string | null
  loading: boolean
}>()

function onFileChanged($event: Event) {
  const target = $event.target as HTMLInputElement
  emits('update', target.files![0])
}

function clear() {
  emits('clear')
}
</script>

<template>
  <div class="grow aspect-square w-full flex justify-center max-h-full">
    <label
      v-if="!props.imageUrl"
      :for="`dropzone-file-${props.index}`"
      class="grow flex flex-col items-center justify-center w-full h-full border-2 border-gray-300 border-dashed rounded-lg cursor-pointer bg-gray-50 dark:hover:bg-gray-800 dark:bg-gray-700 hover:bg-gray-100 dark:border-gray-600 dark:hover:border-gray-500"
    >
      <div class="flex flex-col items-center justify-center pt-5 pb-6">
        <svg
          class="w-8 h-8 sm:mb-4 text-gray-500 dark:text-gray-400"
          aria-hidden="true"
          xmlns="http://www.w3.org/2000/svg"
          fill="none"
          viewBox="0 0 20 16"
        >
          <path
            stroke="currentColor"
            stroke-linecap="round"
            stroke-linejoin="round"
            stroke-width="2"
            d="M13 13h3a3 3 0 0 0 0-6h-.025A5.56 5.56 0 0 0 16 6.5 5.5 5.5 0 0 0 5.207 5.021C5.137 5.017 5.071 5 5 5a4 4 0 0 0 0 8h2.167M10 15V6m0 0L8 8m2-2 2 2"
          />
        </svg>
        <p class="mb-2 hidden sm:inline text-sm font-semibold text-gray-500 dark:text-gray-400">
          {{ $t('formExtra.clickToUpload') }}
        </p>
      </div>
      <input
        :id="`dropzone-file-${props.index}`"
        type="file"
        class="hidden"
        accept="image/png, image/jpeg"
        @change="onFileChanged"
      />
    </label>
    <div v-else class="grow relative">
      <img
        @click="clear"
        :class="`w-full h-full border-2 border-gray-300 border-dashed rounded-lg ${props.loading ? 'opacity-50' : 'cursor-pointer'} object-contain`"
        :src="props.imageUrl!"
      />
      <div
        v-if="props.loading"
        class="absolute top-1/2 left-1/2 -translate-x-1/2 -translate-y-1/2 pointer-events-none"
      >
        <svg
          class="animate-spin -ml-1 h-8 w-8 sm:h-16 sm:w-16 text-white"
          xmlns="http://www.w3.org/2000/svg"
          fill="none"
          viewBox="0 0 24 24"
        >
          <circle
            class="opacity-25"
            cx="12"
            cy="12"
            r="10"
            stroke="currentColor"
            stroke-width="4"
          ></circle>
          <path
            class="opacity-75"
            fill="currentColor"
            d="M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z"
          ></path>
        </svg>
      </div>
    </div>
  </div>
</template>
